object Form1: TForm1
  Left = 322
  Top = 147
  Width = 1245
  Height = 846
  Caption = 'Find All Polygons,  Version 3.2'
  Color = clBtnFace
  Font.Charset = DEFAULT_CHARSET
  Font.Color = clWindowText
  Font.Height = -17
  Font.Name = 'Arial'
  Font.Style = []
  OldCreateOrder = False
  Position = poScreenCenter
  OnCreate = FormCreate
  PixelsPerInch = 120
  TextHeight = 19
  object StaticText1: TStaticText
    Left = 0
    Top = 778
    Width = 1227
    Height = 23
    Cursor = crHandPoint
    Align = alBottom
    Alignment = taCenter
    Caption = 'Copyright '#169' 2013, Gary Darby,  www.DelphiForFun.org'
    Font.Charset = DEFAULT_CHARSET
    Font.Color = clBlue
    Font.Height = -17
    Font.Name = 'Arial'
    Font.Style = [fsBold, fsUnderline]
    ParentFont = False
    TabOrder = 0
    OnClick = StaticText1Click
  end
  object Panel1: TPanel
    Left = 0
    Top = 0
    Width = 1227
    Height = 778
    Align = alClient
    TabOrder = 1
    object Image1: TImage
      Left = 640
      Top = 240
      Width = 529
      Height = 529
    end
    object Panel2: TPanel
      Left = 632
      Top = 16
      Width = 545
      Height = 217
      Caption = 'Panel2'
      Color = clSkyBlue
      TabOrder = 1
      Visible = False
      object ProgressLbl: TLabel
        Left = 56
        Top = 160
        Width = 128
        Height = 23
        Caption = '0 found so far:'
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -20
        Font.Name = 'Arial'
        Font.Style = []
        ParentFont = False
      end
      object Memo3: TMemo
        Left = 72
        Top = 24
        Width = 329
        Height = 121
        Color = clGradientInactiveCaption
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -20
        Font.Name = 'Arial'
        Font.Style = []
        Lines.Strings = (
          '  Finding all polygons for this graph.'
          '   Search may take a few minutes'
          ''
          ' Click anytime to abort the search.'
          '')
        ParentFont = False
        TabOrder = 0
        OnClick = StopBtnClick
      end
      object StopBtn: TButton
        Left = 320
        Top = 160
        Width = 97
        Height = 41
        Caption = 'Stop'
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -27
        Font.Name = 'Arial'
        Font.Style = []
        ParentFont = False
        TabOrder = 1
        OnClick = StopBtnClick
      end
    end
    object PageControl1: TPageControl
      Left = 8
      Top = 24
      Width = 601
      Height = 745
      ActivePage = IntroSheet
      TabOrder = 0
      object IntroSheet: TTabSheet
        Caption = '  Introduction  '
        object Memo1: TMemo
          Left = 0
          Top = 0
          Width = 593
          Height = 711
          Align = alClient
          Color = 14548991
          Lines.Strings = (
            
              'This program searches a given set of nodes and lines to count an' +
              'd display '
            
              'polygons of various types.  Counting polygons embedded in a figu' +
              're is the '
            
              'goal of a number of puzzles.  There are a number of definitions ' +
              'of what '
            
              'makes a polygon but 4 types are selected here.  From simple to c' +
              'omplex '
            'they are:'
            ''
            
              'Primitive:  A single closed figure with no other lines intersect' +
              'ing its edges.'
            
              'Typically these are triangles or quadrilaterals, but could be an' +
              'y number of'
            'sides.'
            ''
            
              'Convex: Combinations of adjoining primitive polygons whose outer' +
              ' outline'
            
              '(the "hull") forms a figure with no "notches", i.e. all turns ar' +
              'e in the same'
            
              'direction, right or left, as the boundary is traveled.  A polygo' +
              'n is convex if'
            
              'and only if all internal angles at the vertices are less than 18' +
              '0'#186'.'
            ''
            
              'Simple:  All polygons which have the same number of edges as ver' +
              'tices.'
            
              'That is, each edge connects two vertices and each vertex has exa' +
              'ctly two'
            
              'edges touching it.  Simple polygons include all of the convex po' +
              'lygons plus'
            'those which are concave, i.e. have "notches".'
            ''
            
              'All types: If we allow two simple polygons to touch at a point w' +
              'ithout sharing'
            
              'an edge, we have a "self intersecting" polygon.  In a single pol' +
              'ygon there'
            
              'may be more than one vertex which is shared by multiple simple p' +
              'olygons,'
            
              'so long as the never share an edge since such sharing would make' +
              ' that'
            
              'edge internal to the polygon.  By definition, an edge must separ' +
              'ate areas'
            'inside the polygon from areas outside.'
            ''
            
              'There are currently 4 predefined figures to choose from: Small, ' +
              'Medium, '
            
              'Large, and Tennis Court.  The "Large" figure in  particular requ' +
              'ires a "depth '
            
              'of search" parameter to keep search time to a reasonable values.' +
              '  Search '
            
              'depth limits the maximum number of edges on polygons detected to' +
              ' 1 less '
            
              'than the depth selected.  I have allowed a maximum depth of leve' +
              'ls, but have '
            
              'only completed searches up to depth 10. Setting a depth limit to' +
              ' 4 will find '
            
              'only triangular polygons and a depth limit of 5 is sufficient to' +
              ' find all '
            'rectangles in the Tennis Court figure.'
            ''
            
              'Everything else you need to know about the program should be sel' +
              'f-'
            
              'evident.  There are separate pages which list the total set of n' +
              'odes and'
            
              'edges found and some or all of the found polygons of the selecte' +
              'd type.'
            
              'Polygons are "named" with a string of letters representing the v' +
              'ertices which'
            
              'are labeled on the display from top to bottom within increasing ' +
              'left to right'
            
              'coordinates.  Clicking on any polygon label in the list will dis' +
              'play that figure'
            'with red edges.'
            ''
            
              'rsion 3.2 does a more thorough search of interior nodes and find' +
              's more '
            
              'polygons of all types up to the specified "Max search depth".  I' +
              't also adds the '
            
              'figure with 15 nodes which duplicates the figure used in our "Ho' +
              'w Many '
            
              'Triangles?" program.  Searching this figure to depth level 4 wil' +
              'l find the same '
            
              '46 triangles reported by the original program.  A search to dept' +
              'h level 8 '
            'takes a few minutes to find 2872 polygons with up to 7 sides.'
            '')
          ScrollBars = ssVertical
          TabOrder = 0
        end
      end
      object LineSheet: TTabSheet
        Caption = '  Corners && Edges  '
        ImageIndex = 1
        object MemoL: TMemo
          Left = 0
          Top = 0
          Width = 593
          Height = 711
          Align = alClient
          ScrollBars = ssVertical
          TabOrder = 0
        end
      end
      object Polygonsheet: TTabSheet
        Caption = '  Polygons  '
        ImageIndex = 2
        object Label3: TLabel
          Left = 0
          Top = 16
          Width = 288
          Height = 19
          Caption = 'Click a line below to see polygon details'
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -17
          Font.Name = 'Arial'
          Font.Style = []
          ParentFont = False
        end
        object Memo2: TMemo
          Left = 0
          Top = 497
          Width = 585
          Height = 209
          Font.Charset = DEFAULT_CHARSET
          Font.Color = clWindowText
          Font.Height = -15
          Font.Name = 'Arial'
          Font.Style = []
          Lines.Strings = (
            'Polygon details')
          ParentFont = False
          TabOrder = 1
        end
        object MemoP: TMemo
          Left = -8
          Top = 40
          Width = 593
          Height = 441
          Lines.Strings = (
            'MemoP')
          ScrollBars = ssBoth
          TabOrder = 0
          OnClick = MemoPClick
        end
      end
    end
    object Panel3: TPanel
      Left = 632
      Top = 16
      Width = 545
      Height = 217
      TabOrder = 2
      object Label4: TLabel
        Left = 323
        Top = 126
        Width = 134
        Height = 19
        Caption = 'Max search depth:'
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -17
        Font.Name = 'Arial'
        Font.Style = []
        ParentFont = False
      end
      object Label2: TLabel
        Left = 331
        Top = 160
        Width = 182
        Height = 41
        AutoSize = False
        Caption = '0.0 seconds to create all polygons for this graph'
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -17
        Font.Name = 'Arial'
        Font.Style = []
        ParentFont = False
        WordWrap = True
      end
      object SelectGraphGrp: TRadioGroup
        Left = 8
        Top = 0
        Width = 201
        Height = 145
        Caption = 'Select a graph to analyze'
        ItemIndex = 0
        Items.Strings = (
          'Small graph'
          'Medium graph'
          'Large graph'
          'Tennis'
          'XXL Triangle Test')
        TabOrder = 0
        OnClick = SelectGraphGrpClick
      end
      object MaxDepthEdt: TSpinEdit
        Left = 464
        Top = 120
        Width = 49
        Height = 29
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -17
        Font.Name = 'Arial'
        Font.Style = []
        MaxValue = 12
        MinValue = 3
        ParentFont = False
        TabOrder = 1
        Value = 8
        OnChange = MaxDepthEdtChange
      end
      object RefreshBtn: TButton
        Left = 14
        Top = 176
        Width = 91
        Height = 25
        Caption = 'Refresh '
        Font.Charset = DEFAULT_CHARSET
        Font.Color = clWindowText
        Font.Height = -20
        Font.Name = 'Arial'
        Font.Style = []
        ParentFont = False
        TabOrder = 2
        OnClick = RefreshBtnClick
      end
      object TypesGrp: TRadioGroup
        Left = 216
        Top = 0
        Width = 169
        Height = 105
        Caption = 'Types to find'
        ItemIndex = 0
        Items.Strings = (
          'All'
          'Simple'
          'Convex'
          'Primitive')
        TabOrder = 3
        OnClick = TypesGrpClick
      end
      object NbrGrp: TRadioGroup
        Left = 408
        Top = 0
        Width = 105
        Height = 105
        Caption = '# to show'
        ItemIndex = 1
        Items.Strings = (
          '10'
          '100'
          '1000'
          'All')
        TabOrder = 4
        OnClick = NbrGrpClick
      end
    end
  end
end
