unit U_FindThePolygons3B;
{Copyright  2013, Gary Darby,  www.DelphiForFun.org
 This program may be used or modified for any non-commercial purpose
 so long as this original notice remains in place.
 All other rights are reserved
 }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  shellAPI, StdCtrls, ExtCtrls,StrUtils, UGeometry, DFFUtils, ComCtrls, UTGraphSearch,
  Spin ;

type
  TForm1 = class(TForm)
    StaticText1: TStaticText;
    Panel1: TPanel;
    Image1: TImage;
    PageControl1: TPageControl;
    IntroSheet: TTabSheet;
    Memo1: TMemo;
    LineSheet: TTabSheet;
    MemoL: TMemo;
    Polygonsheet: TTabSheet;
    MemoP: TMemo;
    Panel2: TPanel;
    Memo3: TMemo;
    StopBtn: TButton;
    ProgressLbl: TLabel;
    Memo2: TMemo;
    Label3: TLabel;
    Panel3: TPanel;
    SelectGraphGrp: TRadioGroup;
    Label4: TLabel;
    MaxDepthEdt: TSpinEdit;
    RefreshBtn: TButton;
    TypesGrp: TRadioGroup;
    NbrGrp: TRadioGroup;
    Label2: TLabel;
    procedure StaticText1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MemoPClick(Sender: TObject);
    procedure TypesGrpClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure SelectGraphGrpClick(Sender: TObject);
    procedure RefreshBtnClick(Sender: TObject);
    procedure MaxDepthEdtChange(Sender: TObject);
    procedure NbrGrpClick(Sender: TObject);
  public
    patoutlines,patlines:array of TPoint;
    PrimitiveEdges:TStringList;  {Hold edges temporarily until nodes have been defined}
    polylist:TStringList;  {the nodes of a single polygon}
    Graph:TGraphList;
    NbrtoShow:integer;
    allbuilt:boolean;
    CurrentPolykey:String;
    maxdepth:integer;
    Polycounts:array[0..3] of integer;{counts of Total, Simple, Convex, and Primitive polygons}

    procedure MakeNodes;
    procedure makeallpolys;
    procedure showPolys(showtype:integer);
    function Getangles(L1,L2:TLine; var Theta1,theta2:extended):extended;
    function NodeIndexFromPoint(p:TPoint):integer;
    function NodeKeyFromPoint(p:TPoint):string;
    function PointFromNodekey(key:string):TPoint;
    function EdgeKeyFromPoints(p1,p2:TPoint):string;
    function EdgeFromEdgeKey(Key:string):TLine;
    procedure drawnode(p:TPoint; ch:char);
    function IsColinear(p1,p2,p3:TPoint):boolean;
    procedure drawalllines(ShowIntersects:boolean; linecolor:TColor);
    function polygonFound:boolean;
    function IsValidPolygon(const points:array of TPoint; polykey:string):boolean;
    function IsSimplePolygon(points:array of Tpoint):boolean;
    function IsConvexPolygon(points:array of Tpoint):boolean;
    function IsPrimitivePolygon(points:array of Tpoint):boolean;
    function NodeLblFromPoint(p:TPoint):char;
    function LP(p:TPoint):char;  {short name for NodeLblFromPoint for debugging}
    function NodePointfromLbl(lbl:char):TPoint;
  end;

var
  Form1: TForm1;

implementation

uses math;

{$R *.DFM}

var
  PatOutline1:array [0..3] of TPoint= ((x:0;y:0), (x:0;y:100),(x:100;y:100),(x:100;y:0));
  {Patlines are the interior pattern lines running from one point to the boundary
  to another the values here are index values into the PatOutlines array}
  {Small}
  Patlines1:array [0..1] of TPoint= ((x:0;y:2), (x:1;y:3));

  {Medium}
  PatOutline2:array [0..5] of TPoint= ((x:100;y:0), (x:400;y:0),(x:500;y:100),(x:500;y:400),
                                    (x:400;y:500), (x:0;y:100));
  Patlines2:array [0..3] of TPoint= ((x:0;y:5),(x:0;y:4),(x:1;y:5),
                                    (x:1;y:3) );

  {Large}
  PatOutline3:array [0..8] of TPoint= ((x:100;y:0), (x:400;y:0),(x:500;y:100),(x:500;y:400),
                                    (x:400;y:500), (x:100;y:500),(x:0; y:400),(x:0;y:100),(x:250;y:250));
  Patlines3:array [0..10] of TPoint= ((x:0;y:6), (x:0;y:5),(x:0;y:4),(x:1;y:5),
                                    {(x:1;y:4), (x:1;y:3),}(x:2; y:6),(x:3;y:7),
                                    (x:0;y:7),(x:1;y:8), (x:2;y:8),(x:3;y:8), (x:4;y:8));

  {{Too large?}
  PatOutline4:array [0..7] of TPoint= ((x:0;y:100),(x:100;y:0), (x:400;y:0),(x:500;y:100),
                                      (x:500;y:400),(x:400;y:500), (x:100;y:500),(x:0; y:400)
                                    );

  Patlines4:array [0..7] of TPoint= ((x:0;y:4),
                                      (x:1;y:5),(x:1;y:6),(x:1;y:7),
                                      (x:2;y:4), (x:2;y:5),(x:2; y:6),
                                      (x:3;y:7));


 {Tennis court outline}

 TennisOutline:array[0..18] of tpoint =(  (x:0;y:0),    (x:45;y:0),   (x:45;y:180), (x:180;y:180), (x:180;y:390), (x:45;y:390),
                                    {6}   (x:0;y:390),  (x:0;y:780),(x:45;y:780), (x:45;y:600), (x:180;y:600),(x:315;y:600),
                                    {12}  (x:315;y:780),(x:360;y:780),(x:360;y:390),(x:315;y:390),(x:315;y:180),(x:315;y:0),
                                    {18}  (x:360;y:0)); //,(x:100;y:0));

 TennisLines:array[0..37] of tpoint=   ((x:0;y:6),
                                       (x:0;y:7), (x:0;y:17),(x:0;y:18),
                                       (x:1;y:5),(x:1;y:9),(x:1;y:8),(x:1;y:17),
                                       (x:2;y:5),(x:2;y:9),(x:2;y:8),(x:2;y:16),
                                       (x:3;y:10),(x:3;y:16),
                                       (x:4;y:10),(x:4;y:15),(x:4;y:14),
                                       (x:5;y:9),(x:5;y:8),(x:5;y:15),(x:5;y:14),
                                       (x:6;y:4), (x:6;y:5),(x:6;y:15),(x:6;y:14),
                                       (x:7;y:12),(x:7;y:13),
                                       (x:8;y:12),(x:8;y:13),
                                       (x:9;y:11),(x:3;y:16),
                                       (x:11;y:15),(x:11;y:16),(x:11;y:17),
                                       (x:12;y:17),
                                       (x:13;y:18),
                                       (x:14;y:18),
                                       (x:15;y:17)

                                       );

  (* {non-working version which only defines nodes in the first array, (not the outline) and defines all edges in the second
     array.   Will be more general, but requires significant code rewrite not yet implemented}
  {Tennis Court}
  TennisNodes:array [0..18] of TPoint = {0}((x:0;y:0), (x:0;y:390), (x:0;y:780),
                                      {3}  (x:45;y:780),(x:45;y:600),(x:45;y:390),(x:45;y:180),(x:45;y:0),
                                  {8}  (x:315;y:0), (x:315;y:180),(x:315;y:390),(x:315;y:600),(x:315;y:780),
                                  {13}  (x:360;y:780), (x:360;y:390),(x:360;y:0),
                                   {16} (x:180;y:180),(x:180;y:390),(x:180;y:600));

  {The indices of additional connecting lines (each TPoint is a line)}
  TennisEdges:array[0..50] of TPoint=  ((x:0;y:1),(x:0;y:2),(x:0;y:7),(x:0;y:8),(x:0;y:15),
                                        (x:1;y:2),(x:1;y:5),(x:1;y:17),(x:1;y:10),(x:1;y:14),
                                        (x:2;y:3),(x:2;y:12), (x:2;y:13),
                                        (x:3;y:4),(x:3;y:12),(x:3;y:5),(x:3;y:6),(x:3;y:7),(x:3;y:12),(x:3;y:13),
                                        (x:4;y:5),(x:4;y:18),(x:4;y:11),
                                        (x:5;y:6),(x:5;y:17), (x:5;y:10),(x:5;y:14),
                                        (x:6;y:7),(x:6;y:16),(x:6;y:9),
                                        (x:7;y:8),(x:7;y:10), (x:7;y:15),
                                        (x:8;y:9),(x:8;y:10),(x:8;y:11),(x:8;y:12),(x:8;y:15),
                                        (x:9;y:10),(x:9;y:11),(x:9;y:12),
                                        (x:10;y:11),(x:10;y:14),
                                        (x:11;y:12),
                                        (x:12;y:13),
                                        (x:13;y:14),(x:13;y:15),
                                        (x:14;y:15),
                                        (x:16;y:17),(x:16;y:18),
                                        (x:17;y:18)
                                        );
 *)

  (*  {Another failed attempt}
   TennisOutline:array[0..15] of tpoint =(  (x:0;y:0),(x:0;y:180),(x:0;y:390), (x:0;y:600), (x:0;y:780),
                                            (x:45;y:780),(x:180;y:780), (x:315;y:780), (x:360;y:780),
                                          (x:360;y:600),(x:360;y:390),(x:360;y:180),(x:360;y:0),
                                          (x:315;y:0),(x:180;y:0),(x:45;y:0)
                                    {18}  );

   TennisLines:array[0..5] of tpoint= ((x:1;y:11),(x:2;y:10),(x:3;y:9),(x:5;y:15),(x:6;y:14),(x:7;y:13)
                                         );
   TennisDeleteNodes:array[0..x] of integer= (1,3,2,7,9,10,11,13,14,15);
 *)


  TwoPi:real=2*Pi;
  Radf:real=Pi/180;  {Radians per degree}
  Deg:char=char($B0);
  r:integer=30;
  {offsets for 32 points at radius "r" around any node, used to find interior
  of each primitive polygon in order to label them}
  typesLbl:array[0..3] of string=('Total count','Simple count','Convex count', 'Primitve count');


{************* FormCreate **********}
procedure TForm1.FormCreate(Sender: TObject);
begin
  Graph:=TGraphList.create;
  PrimitiveEdges:=TStringList.create;
  PrimitiveEdges.Sorted:=true;

  PolyList:=TStringlist.create;
  polylist.sorted:=true;
  
  Nbrgrpclick(sender);
  SelectGraphGrpclick(sender);  {load & make polygons from the default graph }
  Pagecontrol1.activepage:=IntroSheet;
end;

{************* DrawNode ***********}
procedure TForm1.DrawNode(p:TPoint; ch:char);
{Draw a blue Letter at this point}
begin
  with Image1 , canvas, p do
  begin
    font.color:=clblue;
    font.style:=[fsbold];
    font.size:=10;
    pen.width:=1;
    textout(x-4,y-7,ch);
  end;
end;

{************ DrawAllLines ********}
procedure Tform1.drawallLines(ShowIntersects:boolean; linecolor:TColor);
var
  i:integer;
begin
  with image1, canvas do
  begin
    pen.width:=1;
    pen.color:=linecolor;
    rectangle(clientrect);
    pen.width:=2;
    polygon(PatOutlines);

    for i:=0 to high(Patlines) do
    with Patlines[i] do
    begin
      with PatOutlines[x] do moveto(x,y);

      with PatOutlines[y] do lineto(x,y);

    end;
    if showintersects then
    for i:=0 to graph.count-1 do
    with TNode(graph.objects[i]) do  drawnode(point(x,y), char(ord('A')+i));
  end;
end;

{***************** NodeIndexFromPoint ***********}
function TForm1.NodeIndexFromPoint(p:TPoint):integer;
var
  key:string;
begin
  key:=nodekeyfromPoint(p);
  result:=graph.indexof(key);
end;

{***************** NodekeyFromPoint ***********}
function TForm1.NodekeyFromPoint(p:TPoint):string;
begin
  result:=format('%3d%3d',[(p.x),(p.y)]);
end;

{*********** PointFromNodeKey **************}
function TForm1.PointFromNodekey(key:string):TPoint;
{Reverse the string built by NodeKeyFromPoint to return a TPoint record}
begin
  result.x:=strtoint(copy(key,1,3));
  result.y:=strtoint(copy(key,4,3));
end;


{*********** NodeLblFromPoint ************}
function TForm1.NodeLblFromPoint(p:TPoint):char;
var
  n:integer;
  key:string;
begin
  key:=NodekeyfromPoint(p);
  n:=graph.indexof(key);
  if n>=0 then result:=char(ord('A')+n) else result:='?';
end;

{**** LP (Short name for NodeLblFromPoint) ***}
function TForm1.LP(p:TPoint):char;
begin
  result:=nodeLblFromPoint(p);
end;

{************** NodePointFromLbl *********}
function TForm1.NodePointfromLbl(lbl:char):TPoint;
var
 n:integer;
 node:TNode;
begin
  n:=ord(lbl)-ord('A');
  node:=TNode(graph.objects[n]);
  result:=point(node.x, node.y);
end;

{************** EdgeFromEdgeKey *********}
function TForm1.EdgeFromEdgeKey(Key:string):TLine;
var
  i:integer;
  coordinates:array[0..3] of integer;
begin
  for i:=0 to 3 do coordinates[i]:=strtoint(copy(Key,3*i+1,3));
  result.p1:=point(coordinates[0], coordinates[1]);
  result.p2:=point(coordinates[2], coordinates[3]);
end;


{************* EdgekeyFromPoints ************}
function TForm1.edgekeyFromPoints(p1,p2:TPoint):string;
{Make a 12 character string representing an edge line from 2 points}
{Sorted so that furthest left and top point is first}
begin
  if (p1.x<p2.x) or ((p1.x=p2.x) and (p1.y<p2.y))
  then result:=format('%3d%3d%3d%3d',[p1.x,p1.y,p2.x,p2.y])
  else result:=format('%3d%3d%3d%3d',[p2.x,p2.y,p1.x,p1.y]);
end;

function dist(p1,p2:TPoint):integer;
  {distance between two pints}
  begin
    result:=round(sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y)));
  end;

{************ IsColinear **********8}
function TForm1.IsColinear(p1,p2,p3:TPoint):boolean;
{The two shorter sides of a triangle must exceed the length of the third side}
{Here we require that the sum be at least 3 pixels greater than the longest side
 to allow for rounding errors caused by using integer coordinates}
{Colinear will return True of False based on the results of the test}
var
  s1,s2,s3:integer;

  procedure swap(var a,b:integer);
  {swap two integers}
  var temp:integer;
  begin
    temp:=a;
    a:=b;
    b:=temp;
  end;

begin
  s1:=dist(p1,p2);  {Get the side lengths}
  s2:=dist(p2,p3);
  s3:=dist(p1,p3);
  if s1>s2 then swap(s1,s2);  {Sort side by increasing length}
  if s2>s3 then swap(s2,s3);
  if s1+s2>=s3+3 then result:=false else result:=true;;
end;





procedure TForm1.StaticText1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'http://www.delphiforfun.org/',
  nil, nil, SW_SHOWNORMAL) ;
end;


{*********** PolygonFound *********}
function TForm1.PolygonFound:boolean;
{Callback method notified of each polygon as it is found}
{Return True to abort search, False to continue}

  procedure validate(key:string);
  var
    i,n:integer;
  {check for duplicate nodes and first <>last}
  begin
    n:=length(key);
    if ((n div 6)*6<>n) or (n<24) then showmessage('Invalid key length: '+key)
    else   if copy(key,1,6)<>copy(key,n-5,6)
    then showmessage('First and last nodes not equal: '+key)
    else
    begin
      i:=1;
      while i<n-6 do
      begin
        if copy(key,i,6)=copy(key,i+6,6) then
        begin
          showmessage('Duplicate node in key: '+key);
          break;
        end;
        inc(i,6);
      end;
    end;

  end;

var
  i,j,idx,index1,index2:integer;
  s:string;
  polyarray:array of Tpoint;
  polykey,polykey2:string;
  minPointIndex:integer;
  minPoint:TPoint;
  clockwise:boolean;
  area:integer;
  next:integer;
  node:TNode;
  begin
    result:=false;
    setlength(polyarray,graph.q.count);
    minpoint:=point(1000,1000);
    minpointindex:=-1;
    with graph do
    for i:= 0 to Q.count-1 do
    begin
      node:=TNode(Q[i]);
      with node  do
      begin
        {There will be many duplicates generated, one  starting at each corner of the
        polygon.  We'll find the leftmost, topmost corner and rotate the
        array of corners to start with that node.  Then we can check whether it is a
        duplicate before adding the polygon to the Polylist;
        }
        //polyarray[i]:=point(x,y);
        if (x<minPoint.x)
        or ((x=minpoint.x) and (y<minpoint.Y))
        then
        begin
          minpoint.x:=x;
          minpoint.y:=y;
          minPointIndex:=i;
        end;
      end;
    end;


    {make polykeys and rearrange polyarray so that they begin with minimal point}
    s:='';
    polykey:='';
    polykey2:='';
    j:=minpointindex-1;
    next:=0;
    with graph do
    for i:=0 to Q.count-2 do
    begin
      inc(j);
      if j>high(polyarray) then  j:=1;   {don't duplicate the final return point}
      node:=TNode(q[j]);
      idx:=NodeIndexFromPoint(point(node.x,node.y));
      if idx>=0 then
      begin
        s:=char(ord('A')+idx);
        polyarray[next]:=point(node.x,node.y);
        inc(next);
        polykey:=polykey+s;
          {even with the low node first, it could have been traversed in either
          direction.  Polykey2 will reverse the node order to let us check for
          that reversed traverse}
        polykey2:=s+polykey2;
      end
      else
      begin
        showmessage('System error 1');
        halt;
      end;
    end;
    polykey:=Polykey+polykey[1]; {Put the return point back}
    polykey2:=polykey2[length(polykey2)]+polykey2;

    polyarray[high(polyarray)]:=polyarray[0];

    if isvalidPolygon(polyarray, polykey) then
    begin
      area:=polygonarea(polyarray,true,clockwise);
      if area>200 then
      begin
        index1:=polylist.indexof(polykey);
        if index1<0 then
        begin
          index2:=polylist.indexof(polykey2);
          if index2<0
          then
          begin
            polylist.add(polykey);
            // {for debugging} memo1.Lines.add(polykey+' '+ inttostr(area));
            if tag<>0 then result:=true;
          end;
          progresslbl.caption:=inttostr(polylist.count)+' found so far';
          progresslbl.update;
        end;
      end;
    end;
    if tag<>0 then result:=true;
  end;

 type
   TIntersects =class(TObject)
      nodekey:string;
      list:TStringlist;
   end;
{************* MakeNodes ***********}
procedure TForm1.MakeNodes;
{Find all of the intersetcion points}
{Might as well save the line segment information
 as we find the intersections}
 var
  i,j,idx:integer;
  n1,n2:integer;
  p1,p2:TPoint;
  s,s1,s2:string;
  L1,L2:TLine;
  IPReal:TRealpoint;
  IP:TPoint;
  LblLtr:char;
  lbl:string;
  savetype, savenbrtoshow:integer;
  starttime:TDateTime;
  startnode:string;
  colinearList:array of TStringlist;
  colinear:boolean;
     procedure addColinearEntry(index:integer; p1,p2:TPoint);
     var
       d:string;
       s:string;
     begin
       d:=format('%4d',[intdist(p1,p2)]);
       s :=d+nodeKeyfrompoint(p2);
       ColinearList[index].add(s);
     end;
begin
  panel2.BringToFront;
  panel2.Visible:=true;
  panel2.update;
  memoL.clear;
  MemoP.clear;
  pagecontrol1.activepage:=linesheet;
  graph.clear;
  polylist.clear;
  starttime:=now;
  {Make an array of all nodes, given + line intersections}
  allbuilt:=false;
  maxdepth:= maxdepthedt.value;
  tag:=0;
  with graph do
  begin
    primitiveEdges.clear;
    {1. find  the Outline intersections}
    for i:= 0 to high(PatOutlines) do
    with patoutlines[i] do
    begin
      s:=NodekeyFromPoint(patoutlines[i]);
      if not addnode(s,X,Y) then memol.lines.add('Node add failed for nodekey '+s);
      begin
        lblltr:=char(ord('A')+graph.count-1);
        lbl:='('+lblltr+')';
        memoL.lines.add(format('Node #%d%s: %s',[graph.count,lbl,s]));
        drawnode(patoutlines[i],lblltr);
      end;
      if i>0 then  s:=edgekeyfrompoints(patoutlines[i-1], patoutlines[i])
      else s:=edgekeyfrompoints(patoutlines[0], patoutlines[high(patoutlines)]);
      primitiveedges.add(s);
    end;
    {2. Initialize colinear list}
      {Colinearlist will contain a TIntersects object for each patline.  Each string will have
      a 10 byte entry for each node on the line. 4 bytes for distance from start + 6 byte
      nodekey with 3 bytes for x and 3 bytes for y}
    setlength(Colinearlist, length(Patlines));
    for i:= 0 to high(Patlines) do
    begin
      ColinearList[i]:=TStringlist.create;
      with Colinearlist[i] do
      begin
        Sorted:=true;
        duplicates:=dupIgnore;
        startnode :=nodekeyfromPoint(Patoutlines[patlines[i].x]);
        add('0000'+startnode);
      end;
    end;
    {3. check every pattern line to find its intersections}
    for i:= 0 to high(Patlines)  do
    with Patlines[i] do
    begin
      L1:=Line(PatOutlines[x],patoutlines[y]);
      startnode :=nodekeyfromPoint(patoutlines[x]);

      {intersections start with the first border point}
      for j:=0 to high(Patlines) do  {for all other pattern lines}
      if i<>j  then {check  all other pattern lines}
      with patlines[j] do
      begin
         L2:=Line(patoutlines[x],patoutlines[y]);
        {add  L2 as an edge}
        //s :=edgekeyfrompoints(patoutlines[x],patoutlines[y]);
        //if not primitiveedges.Find(s,idx) then primitiveEdges.add(s);
        if extendedlinesIntersect(L1,L2,false,IPreal, colinear) and (not colinear) then
        begin {the 2 lines do intersect}
          Ip.x:=round(IPreal.x);
          Ip.Y:=round(Ipreal.y);
          s:=nodekeyfromPoint(IP); {define the new node}
          addColinearEntry(i,L1.p1,IP);
          addColinearEntry(j,L2.p1,IP);
          if not graph.find(s,idx) then graph.addnode(s);
        end;
      end; {j loop}
      addColinearEntry(i,l1.p1,l1.p2); {the full line}
    end; {i loop}

    finalize;
    {Now run through the intersects list, generating edges for all of the
     intermediate lines segments, i.e. line with point ABCD needs edges AB,AC,AD,BC,BD, and CD created.
    {now display the nodes added}

    for i:=0 to high(Colinearlist) do
    with ColinearList[i] do
    begin
      for n1:=0 to count-2 do
      begin
        s1:=copy(strings[n1],5,6);  {extract the point from the distance}
        for n2:=N1+1 to count-1 do
        begin
          s2:=copy(strings[n2],5,6);
          s:=s1+s2;
          if not primitiveedges.Find(s,idx) then primitiveEdges.add(s);
        end;
      end;
    end;

    for i:=0 to graph.Count-1 do
    begin
      lblltr:=char(ord('A')+i);
      lbl:='('+lblltr+')';
      memoL.lines.add(format('Node #%d%s: %s',[i+1,lbl,s]));
      drawnode(patoutlines[i],lblltr);
    end;
    {Display the edges}
    for i:=0 to PrimitiveEdges.count-1 do
    begin
      s:=PrimitiveEdges[i];
      begin
        s1:=copy(s,1,6);
        s2:=copy(s,7,6);
        p1.X:=strtoint(copy(s1,1,3));
        p1.Y:=strtoint(copy(s1,4,3));
        p2.X:=strtoint(copy(s2,1,3));
        p2.Y:=strtoint(copy(s2,4,3));
        If (s1<>s2)  and not findedge(s1,s2) then
        begin
          if addedge(s1,s2) then
           memoL.lines.add(format('Edge #%d: (%d,%d) -> (%d,%d), Len:%d',
                                    [i+1,p1.x,p1.y,p2.x,p2.y,dist(p1,p2)]))
          else memoL.lines.add(format('Edge add failed: #%d: (%d,%d) -> (%d,%d), Len:%d',
                                    [i+1,p1.x,p1.y,p2.x,p2.y,dist(p1,p2)]));
        end;
      end;
    end;
  end;
  makeallpolys;
  drawalllines(true,clBlack);
  savetype:=typesgrp.itemindex;  {the one the users want to see first}
  savenbrtoshow:=nbrtoshow;
  nbrtoshow:=0;
  for i:=0 to 3 do
  if i<>savetype then
  begin
    showpolys(i); {we'll process all polygontypes just to get the counts}
  end;
  nbrtoshow:=savenbrtoshow;
  typesgrp.ItemIndex:=savetype;
  showpolys(Typesgrp.ItemIndex);
  label2.caption:=format('%.1f seconds to generate the set of all polygons for this graph',[(now-starttime)*secsperday]);
  panel2.Visible:=false;
  for i:=0 to high(colinearlist) do colinearlist[i].Free;
  screen.cursor:=crdefault;
  scrollToTop(memoL);
end;


{*************** Makeallpolys *************}
Procedure TForm1.makeallpolys;
var
  i,j,idx:integer;
  s,s1,s2:string;
  lblltr:char;
  L1,L2:TLine;
  P1,p2:TPoint;
  //starttime:TDatetime;
  OnBorder:boolean;
  startnode,IP:TPoint;
  Lbl1,Lbl2:string;
begin
  maxdepthedtchange(self);
  if not allbuilt then
  begin
    polylist.clear;
    Graph.clear;
    memol.clear;
    {Make an array of all nodes, given + line intersections}
    with graph do
    begin
      drawalllines(true, clblack);
      screen.cursor:=crhourglass;
      {1. find  the Outline intersections}
      for i:= 0 to high(PatOutlines) do
      with patoutlines[i] do
      begin
        s:=NodekeyFromPoint(patoutlines[i]);
        if addnode(s,X,Y) then
        begin
          lblLtr:=char(ord('A')+graph.count-1);
          //lbl:='('+lblLtr+')';
          drawnode(patoutlines[i],lblLtr);
        end;
        (*
        if i>0 then  s:=edgekeyfrompoints(patoutlines[i-1], patoutlines[i])
        else s:=edgekeyfrompoints(patoutlines[0], patoutlines[high(patoutlines)]);
        primitiveedges.add(s);
        *)
      end;
      for i:= 0 to high(Patlines)  do
      with Patlines[i] do
      begin   {check every pattern line to find its intersections}
        L1:=Line(PatOutlines[x],patoutlines[y]);

        startnode:=patoutlines[x];
        for j:=0 to high(Patlines) do  {for all pattern lines}
        if i<>j  then {check  all other pattern lines}
        begin {looking for an intersection}
          with Patlines[j] do L2:=Line(PatOutlines[x],patoutlines[y]);
          if intersect(L1,L2,OnBorder,IP) then  {Intersect checking function}
          begin {the 2 lines do intersect}
            s:=nodekeyfromPoint(IP); {define the new node}
            if (not find(s,idx)) and addnode(s, ip.x, ip.y) then
            begin
              lblLtr:=char(ord('A')+graph.count-1);
              lbl1:='('+lblLtr+')';
              DrawNode(IP,lblLtr);
            end;
            s :=edgekeyfrompoints(startnode,ip);
            If (not equalpoints(startnode,ip)) and (not  primitiveedges.Find(s,idx)) then primitiveedges.add(s);
            startnode:=IP;
          end;
          {add final edge from last IP to end of L1}
          s :=edgekeyfrompoints(startnode,PatOutlines[y]);
          If not primitiveedges.Find(s,idx) then primitiveedges.add(s);
        end;
      end;
      finalize;
      for i:=0 to graph.count-1 do
      with TNode(graph.objects[i]) do
      memoL.lines.add(format('Node #%s: (%d,%d)',[char(ord('A')+i), x,y]));
      {now add the edges saved above}
      for i:=0 to PrimitiveEdges.count-1 do
      begin
        s:=PrimitiveEdges[i];
        begin
          s1:=copy(s,1,6);
          s2:=copy(s,7,6);
          p1.X:=strtoint(copy(s1,1,3));
          p1.Y:=strtoint(copy(s1,4,3));
          p2.X:=strtoint(copy(s2,1,3));
          p2.Y:=strtoint(copy(s2,4,3));
          If (s1<>s2) and not findedge(s1,s2) then
          begin
            Lbl1:=nodelblfrompoint(point(p1.X,p1.y));
            Lbl2:=nodelblfrompoint(point(p2.X,p2.y));
            if not addedge(s1,s2) then Lbl1:='failed '+lbl1;
              memoL.lines.add(format('Edge: %s(%d,%d) -> %s(%d,%d), Len:%d',
                            [Lbl1,p1.x,p1.y,Lbl2,p2.x,p2.y,dist(p1,p2)]));
          end;
        end;
      end;

      {Find closed paths}
      for i:=0 to graph.count-1 do
      begin
        makeAllPolygons(graph[i],maxdepth,PolygonFound);
      end;
    end;
    allbuilt:=true;

  end;
end;

{************** ShowPolys ************}
procedure TForm1.showPolys(showtype:integer);
var
  i,k,nodecount:integer;
  //p1,p2:TPoint;
  //s,s1,s2:string;
  polyarray:array of TPoint;
  s:string;

  polycount:integer;
  Node:TNode;
  idx:integer;

begin
  //panel2.Visible:=true;
  //panel2.update;
  memoP.clear;
  pagecontrol1.activepage:=PolygonSheet;

  {All Polygons have been found}
  polycount:=0;
  for i:= 0 to polylist.count-1 do
  begin
    s:='';
    CurrentPolykey:=polylist[i];
    nodecount:=length(CurrentPolykey);
    setlength(Polyarray, nodecount);
    for k:=0 to high(polyarray) do
    with polyarray[k] do
    begin
      idx:=ord(CurrentPolykey[k+1])-ord('A');
      node:=TNode(graph.objects[idx]);
      x:=node.x;
      y:=node.y;
      if k<=high(polyarray)-1
      then s:=s+'('+CurrentPolykey[k+1] + ' to '+CurrentPolykey[k+2]+ '), ';
    end;
    //typesgrp.ItemIndex:=showtype;
    if (showtype=0)
      or ((showtype=1) and isSimplePolygon(Polyarray))
      or ((showtype=2) and IsConvexPolygon(Polyarray))
      or ((showtype=3) and IsPrimitivePolygon(Polyarray))
    then
    begin
      inc(polycount);
      if memop.lines.count<nbrtoshow then
      begin
        memop.lines.add(format('#%d: %s ',[i+1, s]));
      end;
    end;
  end;
  Polycounts[showtype]:=polycount;
  Typesgrp.items[showtype]:=format('%s (%d)',[typeslbl[showtype],polycount]);
  scrolltotop(memop);
end;

{***************** IsValidPolygon *************}
function  TForm1.IsValidPolygon(const points:array of TPoint; polykey:string):boolean;
{IsValidPolygon returns true for valid simple and self-intersecting polygons
 Excludes adjoining co-linear sides but allows intersecting sides
 (touching or crossing) which do not retrace a side or portion of a side. }
var
 i,j:integer;
 points2:array of TPoint;
 l1,l2:TLine;
 IP:TRealPoint;
 IntIP:TPoint;
 p1,p2:Tpoint;

      {--------------- LiesBetween --------------}
      function liesbetween(L:TLine;p:TPoint):boolean;
      begin
        result:= (((p.x=l.p1.x) and (p.x=L.p2.x)) or
                 ((p.x> min(L.p1.x, L.p2.x)) and (p.x<max(L.P1.x,L.p2.x))))
             and (((p.y=l.p1.y) and (p.y=L.p2.y)) or
             ((p.y> min(L.p1.y, L.p2.y)) and (p.y<max(L.P1.y,L.p2.y))));
      end;

      {-------------- oVERLAPPED -----------}
     function overlapped(L1,L2:TLine):boolean;
     var
        colinear:boolean;
     begin
       result:=false;
       if extendedlinesintersect(L1,L2,false,IP,colinear) then
       begin
         if not colinear then
         begin
           Intip.x:=round(ip.x);
           Intip.y:=round(ip.y);
           if (not equalpoints(Intip,L1.p1))
              and (not equalpoints(Intip,L1.p2))
              and (not equalpoints(Intip,L2.p1))
              and (not equalpoints(Intip,L2.p2))
           then result:=true;
         end
         else
         begin
           (*
           theta1:=gettheta(L1);
           theta2:=gettheta(L2)+180;
           if abs(theta2-theta1)<pi/90 then result:=true
           *)

           if (abs(i-j)=1)
           or {(equalpoints(L1.p1,L2.p1) and} (LiesBetween(L1,L2.p2) or liesbetween(L2,L1.p2))
           or {(equalpoints(L1.p1,L2.p2)  and} (LiesBetween(L1,L2.p1) or liesbetween(L2,L1.p2))
           or {(equalpoints(L1.p2,L2.p1))  and} (LiesBetween(L1,L2.p2) or liesbetween(L2,L1.p1))
           or {(equalpoints(L1.p2,L2.p2))  and} (LiesBetween(L1,L2.p1) or liesbetween(L2,L1.p1))
           or (liesbetween(L1,L2.p1) and liesbetween(L1,L2.p2))
           or (liesbetween(L2,L1.p1) and liesbetween(L2,L1.p2))

            then result:=true;
         end;
       end;
     end;


begin     {IsvalidPolygon}
  result:=true;
  if not equalpoints(points[0],points[high(points)])
  then
  begin
    setlength(points2,length(points)+1);
    points2[high(points2)]:=points[0];
  end
  else setlength(points2,length(points));

  for i:=0 to high(points) do  points2[i]:=points[i];

  for i:=0 to high(points2)-2 do
  begin
    L1.p1:=points2[i]; L1.p2:=points2[i+1];
    for j:=1 to high(points2)-1 do
    if j<>i then
    begin
      p1:=points2[j];
      p2:=points2[j+1];

      L2:=line(p1,p2);
      if overlapped(L1,L2) then
      begin
        result:=false;
        break;
      end;
    end;
    if not result then break;
  end;

end;


{************* IsSimplePolygon ****************}
function TForm1.IsSimplePolygon(points:array of Tpoint):boolean;
var
  i,j:integer;
  L1:TLine;
  stop:integer;
begin
  begin
    if (points[0].x=points[high(points)].x) and (points[0].y=points[high(points)].y)
    then stop:=high(points)-2 else stop:=high(points)-1;
    result:=true;
    for i:=0 to stop do  {don't check the last line which returns home}
    begin
      L1:=line(points[i],points[i+1]);
      for j:=0 to high(points)-1 do
      if (j<>i) and (j<>i+1) then
      begin
        if perpdistance(L1,points[j])<=1 then
        begin
          {is the point at or between the ends of L1?}
          with L1, points[j] do
          begin
            if (minIntValue([p1.x, p2.x, x]) < min(p1.x,p2.x))
              or (maxIntValue([p1.x, p2.x, x]) > max(p1.x,p2.x))
              or (minIntValue([p1.y, p2.y, y]) < min(p1.y,p2.y))
              or (maxIntValue([p1.y, p2.y, y]) > max(p1.y,p2.y))
            then
            else
            begin
              result:=false;
              break;
            end;
          end;
        end;
      end;
    end;
  end;
end;

function TForm1.Getangles(L1,L2:TLine; var Theta1,theta2:extended):extended;
    begin
      theta1:=gettheta(L1);
      theta2:=gettheta(L2);
      result:=Theta2-theta1+pi;
      if result>Pi then repeat result:=result-TwoPi; until result<Pi
    end;

{*************** IsConvexPolygon **************}
function TForm1.IsConvexPolygon(points:array of Tpoint):boolean;
var
  i:integer;
  L1,L2:TLine;
  theta1,theta2,delta:extended;
  clockwise:boolean;
begin
  if not issimplePolygon(points) then
  begin
    result:=false;
    exit;
  end;
  result:=true;
  clockwise:=polybuiltclockwise(points,true); {Used to determine whether turned
                                              angles are + or -}
  L2:=Line(points[0],points[1]);
  theta2:=gettheta(L2);
  for i:=1 to high(points) do
  begin
    L1:=L2;
    if i=high(points) then L2:=line(points[i],points[1])
    else L2:=Line(points[i], points[i+1]);
    Delta:=Getangles(L1,L2, Theta1,theta2);
    if (clockwise and  (delta<pi) and (delta>0))
      or ((not clockwise) and  ((delta>pi) or (delta<0)))
    then
    begin
      result:=false;
      break;
    end;
  end;
end;

{************* IsPrimitivePolygon **************}
function TForm1.IsPrimitivePolygon(Points:array of TPoint):boolean;
{From Version 3.1}
var
  i,j:integer;
  L1,L2,L3:TLine;
  L1P1Matches, L1P2Matches:boolean;
  P3:TPoint;
  m,b:extended;
  s:string;
  Onvertex:boolean;
  IntIP:TPoint;
  PointLoc:PPResult;  {location of point from "PointInPoly" call}

    function Sameline(L1,L2:TLine):boolean;
    begin
      result:= (equalpoints(L1.p1,L2.p1) and equalpoints(L1.P2,L2.p2))
         or (equalpoints(L1.p1,L2.p2) and equalpoints(L1.P2,L2.p1))
    end;


begin
  result:=false;
  if not isSimplePolygon(points) then exit;
  {If there is an edge between any two non-consecutive nodes,
  the polygon is not primitive}

  result:=true;
     {check all edges for those that touch this polygon (P)}
    {Choices for each edge are
      1. Is an edge of P - ignore
      2. Connects two vertices P but not an edge = P is not primitive
      3; One end matches a vertex of P and move inside of P - P is not primitive
      4. Maybe? neither end of edge matches a vertex of P, if edge intersects any side of P, = not primtiv
     }

  for i:= 0 to primitiveedges.count-2 do
  begin
    L1:= edgefromedgekey(primitiveedges[i]);
    s:=lp(L1.p1)+lp(l1.p2);
    if ansicontainsStr(currentpolykey,s) then continue;
    s:=lp(L1.p2)+lp(l1.p1);
    if ansicontainsStr(currentpolykey,s) then continue;

    for j:=0 to high(points)-1 do
    begin
      L2:=Line(points[j], points[j+1]);
      {does it match other vertices of the polygon?}
      L1P1matches:=false;  L1P2matches:=false;
      if equalpoints(L1.p1,L2.p1) or equalpoints(L1.p1,L2.p2) then L1P1Matches:=true;
      if equalpoints(L1.p2,L2.p1) or equalpoints(L1.p2,L2.p2) then L1P2Matches:=true;
      //If l1p1matches and l1p2matches then continue;
      If L1P1matches or L1P2matches then
      begin
        If L1P1Matches then
        begin
          L3.p1:=L1.P1;
          L3.p2:=L1.p2;
        end
        else
        begin
          L3.p1:=L1.P2;
          L3.p2:=L1.p1;
        end;
        {move a few pixels from L3.p1 toward L3.p2 and see if that point is inside Points polygoin}
        {if it is, P is not primitive}

        if l3.p1.x=l3.p2.x then {vertical line}
        begin
           p3.x :=l3.p1.x;
           p3.y:=min(l3.p1.y,l3.p2.y) + 5; {move p3 done the L3 line a bit}
        end
        else
        begin
          p3 :=l3.p2;
          Getequation(L3, m, b);
          if m<0 then p3.x:=p3.x-5 else p3.x:=p3.x+5;
          p3.y:=round(m*(p3.x)+b);
        end;
        PointLoc:=pointinpoly(p3,points);
        If pointLoc=ppinside then
        begin
          result:=false;
         exit;
        end;
      end
      else  {Check for intersection}
      begin
        if intersect(L1,L2,OnVertex,Intip)then
        begin
          if Onvertex {ansicontainsStr(currentpolykey,lp(intip))} then continue;
          result:=false;
          exit;
        end;
      end;
    end;
  end;
end;

(*
{************* IsPrimitivePolygon **************}
function TForm1.IsPrimitivePolygon(Points:array of TPoint):boolean;
var
  i,j:integer;
  L1,L2:TLine;
  s1,s1B,s2:string;
  IP:TRealPoint;
  colinear:boolean;

    function Sameline(L1,L2:TLine):boolean;
    begin
      result:= (equalpoints(L1.p1,L2.p1) and equalpoints(L1.P2,L2.p2))
         or (equalpoints(L1.p1,L2.p2) and equalpoints(L1.P2,L2.p1))
    end;


begin
  result:=false;
  if not isSimplePolygon(points) then exit;
  {If there is an edge between any two non-consecutive nodes,
  the polygon is not primitive}

  result:=true;
  {if any edge not in the polygon but from a node in the polygon intersects another edge of the polygon,
   the polygon is not proimitive}
       {if one end of l2 matches one end of Li abd the oother end is not the
        preceding  of following point i in the points array, check to see if L2
        intersect the polygon.  If it does, the polygon os not primitive.



  if (length(points)=4)  then exit;
     {check all edges for those that touch this polygon (P)}
    {Choices for each edge are
      1. Is an edge of P - ignore
      2. Connects two vertices P but not an edge = P is not primitive
      3; One end matches a vertex of P and move inside of P - P is not primitive
      4. Maybe? neither end of edge matches a vertex of P, if edge intersects any side of P, = not primtiv
     }

  for i:= 0 to primitiveedges.count-2 do
  begin
    L1:= edgefromedgekey(primitiveedges[i]);
    s1:=lp(L1.p1)+lp(l1.p2);
    if s1[1]=s1[2] then continue;
    //if ansicontainsStr(currentpolykey,s) then continue;
    s1B:=lp(L1.p2)+lp(l1.p1);
    {look for an edge that is not part of the input polygon}
    if ansicontainsStr(currentpolykey,s1) or ansicontainsStr(currentpolykey,s1B) then continue;

    for j:=0 to high(points)-1 do
    begin
      L2:=Line(points[j], points[j+1]);
      s2:=lp(L2.p1)+lp(l2.p2);
      {If these lines intersect, the polygon is not primitive}
      {does it match other vertices of the polygon?}
      if extendedlinesintersect(l1,l2,false,ip) then
      begin

        if ((equalpoints(L1.p1, L2.p1) or equalpoints(l1.p1,l2.p2)) and  (pointinpoly(l1.p2,points)=ppoutside))
        or ((equalpoints(L1.p2, L2.p1) or equalpoints(l1.p2,l2.p2)) and  (pointinpoly(l1.p1,points)=ppoutside))
        or colinear
        then
        begin
          result:=false;
          exit;
        end
      end;
    end;
  end;
end;
*)
(*

      L1P1matches:=false;  L1P2matches:=false;
      if equalpoints(L1.p1,L2.p1) or equalpoints(L1.p1,L2.p2) then L1P1Matches:=true;
      if equalpoints(L1.p2,L2.p1) or equalpoints(L1.p2,L2.p2) then L1P2Matches:=true;

      If L1P1matches or L1P2matches then
      begin
        if extendedlinesintersect(l1,l2,false,ip,colinear) and colinear then
        begin
          result:=false;
          exit;
        end;
        If L1P1Matches then
        begin
          L3.p1:=L1.P1;
          L3.p2:=L1.p2;
        end
        else
        begin
          L3.p1:=L1.P2;
          L3.p2:=L1.p1;
        end;
        {move a few pixels from L3.p1 toward L3.p2 and see if that point is inside Points polygoin}
        {if it is, P is not primitive}

        if l3.p1.x=l3.p2.x then {vertical line}
        begin
           p3.x :=l3.p1.x;
           p3.y:=min(l3.p1.y,l3.p2.y) + 5; {move p3 done the L3 line a bit}
        end
        else
        begin
          p3 :=l3.p2;
          Getequation(L3, m, b);
          if m<0 then p3.x:=p3.x-5 else p3.x:=p3.x+5;
          p3.y:=round(m*(p3.x)+b);
        end;
        PointLoc:=pointinpoly(p3,points);
        If pointLoc=ppinside then
        begin
          result:=false;
         exit;
        end;
      end
      else  {Check for intersection}
      begin
        if intersect(L1,L2,OnVertex,Intip)then
        begin
          if Onvertex {ansicontainsStr(currentpolykey,lp(intip))} then continue;
          result:=false;
          exit;
        end;
      end;
    end;
  end;
end;

  (*
      polykey:=polylist[i];
      nodecount:=length(polykey);
      setlength(polyarray, nodecount);
      for k:=0 to high(polyarray) do
      with polyarray[k] do
      begin
        idx:=ord(polykey[k+1])-ord('A');
        node:=TNode(graph.objects[idx]);
        x:=node.x;
        y:=node.y;
        //if k<=high(polyarray)-1 then s:=s+'('+polykey[k+1] + ' to '+polykey[k+2]+ '), ';
      end;

      for  k:=0 to high(polyArray) do
      begin
        l2.p1:=polyarray[k];
        l2.p2:=polyarray[k+1];
        {are one or both ends of this line on the current polygon?}
        count:=0;
        for j:=0 to high(polyArray)-1 do
        begin
          if isOnVertex(polyarray,l
          l1.p1:=polyarray[j];
          l1.p2:=polyarray[j+1];

        if extendedLinesIntersect(L1,L2,false,IP)
        then
        begin

          if (not equalpoints(IP,L1.p1) ) and (not equalpoints(IP,L1.p2))  then
          begin
            result:=false;
            break;
          end;
        end;
      end;
      if not result then break;
    end;
    if not result then break;
  end;
end;
*)

{************ MemoPClick ****************}
procedure TForm1.MemoPClick(Sender: TObject);
var
  i,polynbr:integer;
  s,polynbrstr:string;
  p:tpoint;
  polyarray:array of TPoint;
  P1,p2:TPoint;
  L1,L2:TLine;
  theta1,theta2,delta:extended;
  polykey:string;

  function getnextnode(var s:string; var p:TPoint):boolean;
  var
    i:integer;
  begin
    result:=false;
    i:=1;
    while (i<=length(s)) and (s[i]<>'(') do inc(i);
    if i<=length(s) then
    begin {i points to start of string A to B where a and B are the next 2 point labels}
      p:=NodePointFromLbl(s[i+1]);
      while (i<=length(s)) and (s[i]<>')') do inc(i);
      result:=true;
      delete(s,1,i);
    end;
  end;

begin
  i:=MemoLineClicked(Memop);
  s:=memop.lines[i];
  setlength(polyarray,100);
  memo2.clear;
  polynbr:=-1;
  if length(s)=0 then exit;
  if s[1]='#' then
  begin
    i:=2;
    while s[i] <> ':' do inc(i);
    polynbrstr:=copy(s,2,i-2);
    polynbr:=strtoint(polynbrstr)-1;
    polykey:=polylist[polynbr];
    memo2.lines.add('#'+polynbrstr+' '+ polykey);
  end
  else memo2.lines.add('#' + inttostr(i)+'???');
  i:=0;
  while getnextnode(s,p) do  {get the start node for the next edge}
  begin
    polyarray[i]:=p;
    inc(i);
  end;
  polyarray[i]:=polyarray[0];  {return to start node}
  setlength(polyarray,i+1);
  If isvalidPolygon(polyarray, polylist[polynbr]) then
  with image1.canvas do
  begin
    drawalllines(True,clSilver);
    pen.color:=clred;
    pen.width:=2;
    brush.style:=bssolid;
    if (typesgrp.itemindex=2)
    then if not isconvexPolygon(polyarray) then showmessage('Error');
    p1:=polyarray[0];
    p2:=polyarray[1];
    L2:=line(p1,p2);
    moveto(p1.x,p1.y);
    lineto(p2.x,p2.Y);
    polykey:=polykey+polykey[2];  {repeat end of 1st line for angle display}
    for i:=1 to high(polyarray) do
    begin
      L1.p1:=L2.p1;
      L1.p2:=l2.p2;
      p1:=polyarray[i];
      if i=high(polyarray) then p2:=polyarray[1]
      else p2:=polyarray[i+1];
      L2:=line(p1,p2);
      delta:=getangles(L1,L2, theta1,theta2);
      lineto(p2.x,p2.y);
      image1.update;
      sleep(500);

      memo2.lines.add(format('Corner: %s (%d,%d) to (%d,%d) to (%d,%d) has interal angle %.1f%s ',
                  [copy(polykey,i,3),l1.p1.x,l1.p1.y,l1.p2.x, l1.p2.y,
                  l2.p2.x, l2.p2.y, delta*180/pi, deg]));
      (* {with individual line angles for debugging}
      memo2.lines.add(format('Corner: (%d,%d) to (%d,%d) {%.1f%s} to (%d,%d) {%.1f%s} has interal angle %.1f%s ',
                  [l1.p1.x,l1.p1.y, l1.p2.x, l1.p2.y,theta1*180/pi, deg, l2.p2.x, l2.p2.y,
                   theta2*180/pi, deg, delta*180/pi, deg]));
      *)

    end;
    application.ProcessMessages;
    pen.width:=1;
  end
  else memo2.lines.add('Not a valid polygon');
end;

{*************** TypesgrpClick ************}
procedure TForm1.TypesGrpClick(Sender: TObject);
begin
  showpolys(Typesgrp.ItemIndex);
end;

{*************** StopBtnClick *************}
procedure TForm1.StopBtnClick(Sender: TObject);
begin
  tag:=1;
  application.ProcessMessages;
end;

{*********** SelectGraphGrpClick **************}
procedure TForm1.SelectGraphGrpClick(Sender: TObject);

    {---------- CopyGraph --------------}
    procedure copygraph(outlines, intLines:array of TPoint);
    {Copy one of several sets of outline and interior lines to a common set of arrays}
    var i:integer;
        scale,figscale:real;
        minx,miny,maxx,maxy:real;
        offsetx,offsety:integer;
    begin
      setlength(patlines, length(intlines));
      setlength(patoutlines,length(outlines));
      for i:=0 to high(outlines) do patoutlines[i]:=outlines[i];
      for i:=0 to high(intlines) do patlines[i]:=intlines[i];
      minx:=9999; miny:=9999;
      maxx:=0; maxy:=0;

      for i:=0 to  high(PatOutlines) do
      with PatOutlines[i] do
      begin
        maxx:=max(maxx,x);
        minx:=min(minx,x);
        maxy:=max(maxy,y);
        miny:=min(miny,y);
      end;
      with image1 do
      begin
        figscale:= max(maxx-minx,maxy-miny);
        scale:= 9*min(width,height) / (10*figscale);
        offsetx:=width div 20;
        offsety:=height div 20;
      end;
      for i := 0 to high(PatOutlines) do
      with PatOutlines[i]  do
      begin
        x:=offsetx+round(x*scale);
        y:=offsety+round(y*scale);
      end;
      MakeNodes;
      //showpolys(Typesgrp.ItemIndex);
    end;
begin  {selectGraphGrpclick}
  allbuilt:=false;
  case  Selectgraphgrp.itemindex of
    0:
      begin
        {Small}
        copygraph(patoutline1,patlines1);
      end;
    1:
      begin
       {Medium}
        copygraph(patoutline2,patlines2);
      end;
    2: begin
         {Large}
         copygraph(patoutline3,patlines3);
       end;
    3: begin
         {Tennis}
         copygraph(TennisOutline,TennisLines);
       end;
    4: begin
         {XLL Large}
         maxdepthEdt.value:=4;
         copygraph(patoutline4,patlines4);
       end;
     end;
     
end;

{************ RefreshBtnClick ***********}
procedure TForm1.RefreshBtnClick(Sender: TObject);
begin
  MakeNodes;
end;

procedure TForm1.MaxDepthEdtChange(Sender: TObject);
begin
  maxdepth:=MaxDepthEdt.value;  {New max polygon search depth}
end;

procedure TForm1.NbrGrpClick(Sender: TObject);
begin
  case nbrgrp.itemindex of
    0:nbrToShow:=10;
    1:nbrtoshow:=100;
    2:nbrtoshow:=1000;
    3:nbrtoshow:=10000000; {all}
  end;
  showpolys(typesgrp.ItemIndex)
end;

end.

